<?php

enum Role
{
    case Admin;
    case Moderateur;
    case Utilisateur;
}

class Alumni{

    /**
     * @var int Identifiant
     */
    private int $id;

    /**
     * @var string Email
     */
    private string $email;

    /**
     * @var string Mot de passe
     */
    private string $motDePasse;

    /**
     * @var Role Role
     */
    private Role $role;

    /**
     * @param int $id
     * @param string $email
     * @param string $motDePasse
     * @param Role $role
     */
    public function __construct(int $id, string $email, string $motDePasse, Role $role)
    {
        $this->id = $id;
        $this->email = $email;
        $this->motDePasse = $motDePasse;
        $this->role = $role;
    }

    /**
     * @return string
     */
    public function getId() : string
    {
        return $this->id;
    }

    /**
     * @return string
     */
    public function getEmail() : string
    {
        return $this->email;
    }

    /**
     * @return string
     */
    public function getMotDePasse(): string
    {
        return $this->motDePasse;
    }

    public function getRole(): Role
    {
        return $this->role;
    }
}